/*
 * Created by SharpDevelop.
 * User: Thiagarajan Alagarsamy
 * Date: 1/19/2007
 * Time: 11:28 AM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;

namespace SnapScreen
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm
	{
		// variable to store output file name
		private string strFilename;
		
		// Property for storing and retrieving output file name
		public string filename
		{
			get{return strFilename;}
			set{strFilename=value;}
		}
		
		[STAThread]
		public static void Main(string[] args)
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			Application.Run(new MainForm());
		}
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
	
		void BtnSnapClick(object sender, System.EventArgs e)
		{
			// Check user clicked OK button
			// Get the filename and put in the textbox and property
			if(saveFileDialog1.ShowDialog()!=DialogResult.Cancel)
			{
				filename=saveFileDialog1.FileName;
			}
			else
				return;
			// Check if output file name is selected
			if(filename!=null)
			{
				this.Hide();
				
				// Slow the thread to hide the application before taking the snap
				Thread.Sleep(200);
				
				// Setting the size of the screen for the bitmap
				//Bitmap bmp= new Bitmap(Screen.PrimaryScreen.Bounds.Width,Screen.PrimaryScreen.Bounds.Height,PixelFormat.Format32bppArgb);
				Bitmap bmp= new Bitmap(this.Width,this.Height,PixelFormat.Format32bppArgb);
				
				// Creating graphic object from the image
				Graphics gr=Graphics.FromImage(bmp);
				
				// Taking the snapshot
				//gr.CopyFromScreen(Screen.PrimaryScreen.Bounds.X, Screen.PrimaryScreen.Bounds.Y, 0, 0, Screen.PrimaryScreen.Bounds.Size, CopyPixelOperation.SourceCopy);
				gr.CopyFromScreen(this.Left, this.Top, 0, 0, this.Size, CopyPixelOperation.SourceCopy);
				
				// Saving file in the selected image format
				switch(saveFileDialog1.FilterIndex)
				{
					case 1: 
						bmp.Save(filename,ImageFormat.Jpeg);
						break;
					case 2:
						bmp.Save(filename,ImageFormat.Png);
						break;
					case 3:
						bmp.Save(filename,ImageFormat.Bmp);
						break;
					case 4:
						bmp.Save(filename,ImageFormat.Gif);
						break;
					case 5:
						bmp.Save(filename,ImageFormat.Icon);
						break;
					case 6:
						bmp.Save(filename,ImageFormat.Tiff);
						break;
				}
				
				// Showing the application again
				this.Show();
				
				// Display success message and prompt the user to see the image
				if(MessageBox.Show("Screen captured successfully! Do you want to see the captured image?","Snap Screen Message", MessageBoxButtons.YesNo, MessageBoxIcon.Asterisk)==DialogResult.Yes)
				{
					Process pr= new Process();
					pr.StartInfo.FileName=filename;
					pr.Start();
				}
				
			}
			else
				MessageBox.Show("Please select a file name to save!", "Snap Screen Message", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
		
		}
	}
}
